<?php

namespace AppBundle\Controller;

use AppBundle\Entity\Products;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class ProductsController extends Controller
{

    /**
     * @Route("/{_locale}/products/gestion")
     */
    public function gestionAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $paginator  = $this->get('knp_paginator');

        $products = $em->getRepository('AppBundle:Products')->findBy(array('deleted' => 0));

        $pagination = $paginator->paginate(
            $products, /* query NOT result */
            $request->query->getInt('page', 1)/*page number*/,
            2/*limit per page*/
        );
    
        return $this->render('/products/gestion.html.twig', array(
            'pagination' => $pagination,
        ));
    }

    /**
     * @Route("/products/add")
     */
    public function addAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();

        return $this->render('/products/add.html.twig');
    }

    /**
     * @Route("/products/save")
     */
    public function saveAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $nombre = $request->get("nombre");
        $stock = $request->get("stock");
        $photo = $request->files->get('photo');

        $filename = null;
        if (!is_null($photo)) {
            $filename = uniqid() . "." . $photo->getClientOriginalExtension();
            $path = "products/";
            $photo->move($path, $filename);
        }

        $product = new Products();
        $product->setNombre($nombre);
        $product->setStock($stock);
        $product->setPhoto($filename);
        $product->setDeleted(0);

        $em->persist($product);
        $em->flush();

        return new Response(1);
    }
}
