# Instalación
```
composer create-project symfony/framework-standard-edition my_project_name "3.4.*"
```
# Controller
## Prueba 1
```php
/**
 * @Route("/", name="homepage")
 */
public function indexAction(Request $request)
{
    echo "<h1>prueba 1</h1>";
    die();
}
```
## Prueba 2
```php
/**
 * @Route("/prueba-dos")
 */
public function pruebaDosAction(Request $request)
{
    return new response("<h1>Prueba 2</h1>");
}
```
## Prueba 3 ( TWIG )
```php
/**
 * @Route("/prueba-tres")
 */
public function pruebaTresAction(Request $request)
{
    return $this->render('/default/index.html.twig');
}
```
# AJAX
## Base de Datos
```sh
php bin/console doctrine:mapping:import AppBundle yml
php bin/console doctrine:generate:entities AppBundle
```

## TWIG products
```html
{% for item in products %}
<tr>
    <td>{{ item.idProducts }}</td>
    <td>{{ item.nombre }}</td>
    <td>{{ item.stock }}</td>
</tr>
{% endfor %}
```

## add product
```html
{% extends 'base.html.twig' %}

{% block body %}
    <form id="formProducts"> 
        <label>Nombre</label>
        <input type="text" name="nombre">
        <br/>
        
        <label>Stock</label>
        <input type="number" name="stock">
        <br/>
        <br/>
        <button type="button" onClick="save()">Guardar</button>
    </form>
{% endblock %}

{% block javascripts %}
<script>
function save(){
    $.ajax({
        url:"{{path('app_products_save')}}",
        data:new FormData($('#formProducts')[0]) ,
        type:"post",
        contentType:false,
        processData:false,
        cache:false,
        dataType:"json",
        error:function(err){
            console.error(err);
        },
        success:function(idProduct){
            document.getElementById("formProducts").reset();
            alert('Producto añadido');
        }
    });
}
</script>
{% endblock %}
```

```php
/**
 * @Route("/products/add")
 */
public function addAction(Request $request)
{
    $em = $this->getDoctrine()->getManager();

    return $this->render('/products/add.html.twig');
}

/**
 * @Route("/products/save")
 */
public function saveAction(Request $request)
{
    $em = $this->getDoctrine()->getManager();
    $nombre = $request->get("nombre");
    $stock = $request->get("stock");

    $product = new Products();
    $product->setNombre($nombre);
    $product->setStock($stock);
    $product->setDeleted(0);

    $em->persist($product);
    $em->flush();

    return new Response(1);
}
```

## Photos
Controller
```php
$photo = $request->files->get('photo');

$filename = null;
if (!is_null($photo)) {
    $filename = uniqid() . "." . $photo->getClientOriginalExtension();
    $path = "products/";
    $photo->move($path, $filename);
}

```
HTML
```html
<input type="file" name="photo" />
```

## KNP Paginator
https://github.com/KnpLabs/KnpPaginatorBundle


## Theme 
https://bootswatch.com/